// Copyright © 2017 Project Golan, all rights reserved.
#include "m_math.h"

#include <stdlib.h>

// Extern Functions ----------------------------------------------------------|

//
// M_AABBPoint
//
bool M_AABBPoint(fixed xl, fixed yl, fixed xu, fixed yu, fixed xp, fixed yp)
{
   return xp > xl && yp > yl && xp < xu && yp < yu;
}

//
// M_Random_Float
//
float M_Random_Float(float min, float max)
{
   if(max < min) {float min_ = min; min = max; max = min_;}
   return (rand() / (double)RAND_MAX) * (max - min) + min;
}

// EOF
